/*
********************************
* jvmMain - top object for JVM *
********************************
*/

#define Stamp     1  //0=propeller board, 1=spinstamp
#define commPort  1  //0=none, 1=propeller TX/RX, 2=spin stamp SOUT/SIN/ATN

  
#include "jvmNative.c"
#include "jvmEngine.c"
#include "jvmJavaProg.c"


void main(void) {
  long c;
/* setup clock */
  if (Stamp == 0) {
    clkset(16,5000000);
  }
  if (Stamp == 1) {
    clkset(8,10000000);
  }
/* application starts here */
  comStart(commPort,true);
  setReset();
  while (true) { //keep running
    vpStop();
    init(getJavaProgram(),JAVASIZE,commPort); //initialize jvm registers and pass javaProg properties
    if (isReset()) {
      doReset();
      clearReset();
      do {
        c = doDebug(2000);
      } while (c != -1);
    }
	else {
      //mainloop
      vpStart();                      //startup COGs for VP code
      while (!isReset()) {
        doDebug(0);                   //check for debug commands
        c = doBytecode();             //execute next bytecode
        if ((c >= 0) && (c < 48)) {
          doNative(c);                //invoke a native function
          incJvmPC(3);                //move to next bytcode
		}
		else {
          //add userdefined native functions here
        }
	  }
	}
  }
}        
     